      SUBROUTINE SVALUE(N,X,F,B,C,D,T,S,IFLAG)
      INTEGER N,IFLAG
      DOUBLE PRECISION X(N),F(N),B(N),C(N),D(N),T,S
C
C  EVALUATE SPLINE S AT T USING COEFFICIENTS FROM SPCOEF.
C
C  INPUT PARAMETERS
C    N,X,F,B,C,D ARE THE SAME AS IN SPCOEF
C    T = POINT WHERE SPLINE IS TO BE EVALUATED
C  OUTPUT PARAMETERS
C    S = VALUE OF SPLINE AT T
C    IFLAG = 0  NORMAL RETURN
C          =-1  N .LE. 1
C          = 1  T .LT. X(1)
C          = 2  T .GT. X(N)
C
C  LOCAL VARIABLES
      INTEGER I
      DOUBLE PRECISION DT
      DATA I/1/
C
C  SEARCH FOR CORRECT INTERVAL FOR T.
C
      IF (N .LE. 1) GOTO 30
      IF (T .LT. X(I)) I=1
   10 IF(T .LT. X(I+1)  .OR.  I .EQ. N-1) GOTO 20
      I = I+1
      GOTO 10
   20 IFLAG = 0
      IF (T .LT. X(1)) IFLAG = 1
      IF (T .GT. X(N)) IFLAG = 2
C
C  EVALUATE CUBIC POLYNOMIAL ON (X(I) , X(I+1)).
C
      DT = T-X(I)
      S = F(I)+DT*(B(I)+DT*(C(I)+DT*D(I)))
      RETURN
   30 IFLAG = -1
      RETURN
      END
